#!/bin/sh
# Writes to remote.subconf address of the HENI VPN server instance which serves this device

# Adresses of vpn server instances, semicolon-separated
# The first on the list server devices where (MAC % 2) == 0, the second == 1, etc.
SERVERS='192.168.42.42 1110;192.168.42.42 1111'

FILE='/etc/openvpn/remote.subconf'

mac="$(cat /sys/class/net/eth0/address)"
if [ $? -eq 0 ]; then
	last_letter="$(echo "$mac" | tail -c 3 | head -c 1)" && \
	server_id=$(( 0x${last_letter} % 2 + 1 )) && \
	server="$(echo "$SERVERS" | cut -d ';' -f "$server_id")" && \
	echo "remote $server" > "$FILE"
fi
