#ifndef _ERR_H__
#define _ERR_H__

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

// We'll use stdout here because otherwise the order of printfs is
// undeterministic which can be sometimes confusing
#define LOG(name, err) \
    fprintf(stdout, "File %s, line %d, '%s' failed with errno=(%d, %s)\n", \
             __FILE__,__LINE__, name, err, strerror(err))

#define SYSERR(name, err) {\
    LOG(name, err); \
    exit(1); \
}

#define SYS_FAIL_IF(cond) if ((cond)) SYSERR((#cond), errno)

#define SYS_FAIL_IF_ERR(cond, err) if ((cond)) SYSERR((#cond), err)

#endif
