#!/usr/bin/env lua

local out = io.stderr

function sleep(ms)
  local ntime = os.clock() + ms/1000
  repeat until os.clock() > ntime
end

function string.trim(s)
    return (s:gsub("^%s*(.-)%s*$", "%1"))
end

if #arg < 1 then
  out:write("Usage: ./collect-icount.lua load_identification (ex. '100ohm' or 'node') \n")
  os.exit(1)
end
load_id = arg[1]

mac_f = io.open("/sys/class/net/eth0/address", "r")
mac = string.trim(mac_f:read("*line"))
mac_f:close()

icount = io.open("/dev/icount", "r")
for i=1,10 do
 vals = string.trim(icount:read("*line"))
 ts, val = string.match(vals, '(%d+) (%d+)')
 print(string.format('%s,%s,%d,%s,%s', mac, load_id, i, ts, val))
 sleep(1000)
end
icount:close()
