#ifndef _ICOUNT_I2C_H
#define _ICOUNT_I2C_H

#include <linux/types.h>
#include <linux/i2c.h>
#include <linux/workqueue.h>

#define ICOUNT_NAME "icount"
#define DRV_NAME	ICOUNT_NAME "-i2c"
#define DRV_DESC	"iCount driver"
#define DRV_VERSION	"0.0.1"

#define ICOUNT_DEVICE_NAME ICOUNT_NAME
#define ICOUNT_CLASS_NAME "power"

#define ICOUNT_I2C_ADDRESS	0x51

static const unsigned ICOUNT_PERIODIC_DELAY_MS = 1000;

static int icount_i2c_probe(struct i2c_client *client, const struct i2c_device_id *id);
static int icount_periodic_init(void);
static void icount_periodic_exit(void);
static void icount_i2c_periodic(struct work_struct *work);
static int icount_i2c_set_register(u8 reg, u8 val);
static int icount_i2c_get_register(u8 reg, u8 * buf, size_t len);
static int icount_i2c_init(void);
static int icount_i2c_remove(struct i2c_client *client);
static int icount_i2c_open(struct inode *inodep, struct file *filep);
static int icount_i2c_release(struct inode *inodep, struct file *filep);
static int icount_i2c_fetch(void);
static unsigned long long icount_i2c_format_ts(void);
static unsigned long long icount_i2c_format_value(void);
static ssize_t icount_i2c_read(struct file *filep, char *buffer, size_t len, loff_t *offset);
static ssize_t icount_i2c_write(struct file *filep, const char *buffer, size_t len, loff_t *offset);
static int icount_chardev_init(void);
static void icount_chardev_exit(void);

#endif
